dnl
dnl XML_HOOK (script-if-xml-found, failflag)
dnl
dnl If failflag is "failure", script aborts due to lack of XML
dnl 
dnl Check for availability of the libxml library
dnl the XML parser uses libz if available too
dnl
dnl
dnl This macro was modified by Arturo Tena <arturo@directmail.org>
dnl to use it by xls2xml <http://arturo.directmail.org/filtersweb>
dnl

AC_DEFUN([XML_HOOK],[
	if test "$XML_CONFIG_DIR" = no; then
		AC_PATH_PROG(XML_CONFIG,xml-config,no)
	else
		TEMP_PATH="$XML_CONFIG_DIR"
		AC_PATH_PROG(XML_CONFIG,xml-config,no,$TEMP_PATH)
	fi
	if test "$XML_CONFIG" = no; then
		if test x$2 = xfailure; then
			AC_MSG_ERROR(Could not find xml-config)
		fi
	fi
	AC_CHECK_LIB(xml, xmlNewDoc, [
		$1
		AC_SUBST(XML_LIB)
		AC_SUBST(XML_CFLAGS)
		XML_LIB=`$ac_cv_path_XML_CONFIG --libs`
		XML_CFLAGS="`$ac_cv_path_XML_CONFIG --cflags`\/..\/.."
dnl		XML_CFLAGS="`$ac_cv_path_XML_CONFIG --cflags` `$ac_cv_path_XML_CONFIG --cflags`\/..\/.."
dnl \/..\/.. = to work with libxml < 1.7.0
	], [
		if test x$2 = xfailure; then 
			AC_MSG_ERROR(Could not link sample xml program)
		fi
	], `$ac_cv_path_XML_CONFIG --libs`)
])

AC_DEFUN([XML_CHECK], [
	XML_HOOK([],failure)
])
