/*
   xls2xml: Converts from Microsoft Excel files to XML.
   Copyright 1999  Roberto Arturo Tena Sanchez

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published  by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 */
/*
   Roberto Arturo Tena Sanchez <arturo@directmail.org>
 */

#ifndef BRDB_H
#define BRDB_H

#ifdef __cplusplus
extern "C" {
#endif


#include <cole/cole.h>
#include <gnome-xml/tree.h>
#include <biffrec.h>
#include <param.h>


#define process_function(f) int (*f) (void)

/* brdb = biff record data base */
struct str_brdb
{
  U16 opcode;
  process_function (f);		/* function that process this biff record */
  U16 fixed_size;		/* if any, if not write 0 in this field */
  char * name;			/* printable name */
  char * desc;			/* printable description */
};
typedef struct str_brdb record_brdb;


extern U32 size_record_brdb;
extern record_brdb brdb[];
extern U32 size_brdb;


int cmp_record_brdb (const void * a, const void * b);


#ifdef __cplusplus
}
#endif

#endif /* BRDB_H */

