/*
   xls2xml: Converts from Microsoft Excel files to XML.
   Copyright 1999  Roberto Arturo Tena Sanchez

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published  by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 */
/*
   Roberto Arturo Tena Sanchez <arturo@directmail.org>
 */

#include <cole/cole.h>
#include <biffrec.h>
#include <gnome-xml/tree.h>
#include <p.h>
#include <param.h>
#include <xmlunicode.h>


/* CALCMODE - Calculation Mode */
int
p0D (void)
{
  assert_return (xls2xml, parameters->record.opcode == 0x0D, 19);
  test (parameters->record.size >= 2, 15);
  test (parameters->this_sheet != NULL, 15);

  switch (fil_sreadU16 (parameters->record.info))
  {
  default: /* 0x00 */
    test (xmlNewChild (parameters->this_sheet, NULL, (unsigned char *)"calculationmode", (unsigned char *)"manual") != NULL, 10);
    break;
  case 0x01:
    test (xmlNewChild (parameters->this_sheet, NULL, (unsigned char *)"calculationmode", (unsigned char *)"auto") != NULL, 10);
    break;
  case 0x02:
    test (xmlNewChild (parameters->this_sheet, NULL, (unsigned char *)"calculationmode", (unsigned char *)"autoexcepttables") != NULL, 10);
    break;
  }

  return 0;
}
