/*
   xls2xml: Converts from Microsoft Excel files to XML.
   Copyright 1999  Roberto Arturo Tena Sanchez

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published  by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 */
/*
   Roberto Arturo Tena Sanchez <arturo@directmail.org>
 */

#include <cole/cole.h>
#include <biffrec.h>
#include <gnome-xml/tree.h>
#include <p.h>
#include <param.h>
#include <xmlunicode.h>


/* WRITEACCESS - Write Access User Name */
int
p5C (void)
{
  U8 user_name[32];
  U8 len_user_name;
  
  assert_return (xls2xml, parameters->record.opcode == 0x5C, 19);

  switch (parameters->biff_version)
  {
  case BIFF_5_7:
    test (parameters->record.size >= 32, 15);
    len_user_name = *(parameters->record.info);
    test (len_user_name <= 31, 15);
    memcpy (user_name, parameters->record.info+1, len_user_name);
    user_name[len_user_name] = 0;
    test (xmlNewChild (parameters->xml_tree_shortcuts.defaults,
		       NULL, (unsigned char *)"username", user_name) != NULL, 10);
    return 0;
  case BIFF_8:
    test (parameters->record.size >= 112, 15);
    return write_unicode_xml_child (parameters->xml_tree_shortcuts.defaults,
				    NULL, "username",
				    parameters->record.info,
				    parameters->record.size, NULL);
  default:
    return 15;
  }
}
