/*
   xls2xml: Converts from Microsoft Excel files to XML.
   Copyright 1999  Roberto Arturo Tena Sanchez

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published  by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 */
/*
   Roberto Arturo Tena Sanchez <arturo@directmail.org>
 */

#include <cole/cole.h>
#include <biffrec.h>
#include <gnome-xml/tree.h>
#include <p.h>
#include <param.h>
#include <xmlunicode.h>


/* BOUNDSHEET - Sheet Information */
int
p85 (void)
{
  U16 flags;

  assert_return (xls2xml, parameters->record.opcode == 0x85, 19);
  verbose ("FIXME: 85: should we read and store start of the BOF record?");
  assert_return (xls2xml, parameters->xml_tree_shortcuts.sheets != NULL, 19);

  switch (parameters->biff_version)
  {
  case BIFF_5_7:
    test (parameters->record.size >= 8, 15);
    flags = fil_sreadU16 (parameters->record.info+4);
    switch (flags & 0x000f)
    {
    case 0x0000:
      /* worksheet or dialog sheet */
      test_call (create_new_sheet (NULL), int);
      break;
    case 0x0001:
      /* Microsoft Excel 4.0 macro sheet */
      verbose ("FIXME: 85: Microsoft Excel 4.0 macro sheet");
      break;
    case 0x0002:
      /* Chart */
      verbose ("FIXME: 85: Chart sheet");
      break;
    case 0x0006:
      /* Visual Basic module */
      verbose ("FIXME: 85: Visual Basic sheet");
      break;
    default:
      return 15;
      break;
    }
    break;
  case BIFF_8:
    test (parameters->record.size >= 7, 15);
    flags = fil_sreadU16 (parameters->record.info+4);
    switch (flags & 0x000f)
    {
    case 0x0000:
      /* worksheet or dialog sheet */
      test_call (create_new_sheet (NULL), int);
      break;
    case 0x0001:
      /* Microsoft Excel 4.0 macro sheet */
      verbose ("FIXME: 85: Microsoft Excel 4.0 macro sheet");
      break;
    case 0x0002:
      /* Chart */
      verbose ("FIXME: 85: Chart sheet");
      break;
    case 0x0006:
      /* Visual Basic module */
      verbose ("FIXME: 85: Visual Basic sheet");
      break;
    default:
      return 15;
      break;
    }
    break;
  default:
    return 15;
  }

  return 0;
}
