/*
   xls2xml: Converts from Microsoft Excel files to XML.
   Copyright 1999  Roberto Arturo Tena Sanchez

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published  by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 */
/*
   Roberto Arturo Tena Sanchez <arturo@directmail.org>
 */

#include <cole/cole.h>
#include <biffrec.h>
#include <gnome-xml/tree.h>
#include <p.h>
#include <param.h>
#include <xmlunicode.h>


/* MULBLANK - Multiple Blank Cells */
int
pBE (void)
{
  U16 first_col;
  U16 last_col;
  U16 row;
  U16 i;
  U8 * rkreg;
  xmlNodePtr cell;

  assert_return (xls2xml, parameters->record.opcode == 0xBE, 19);
  test (parameters->record.size >= 6, 15);
  assert_return (xls2xml, parameters->this_cells != NULL, 19);

  first_col = fil_sreadU16 (parameters->record.info + 2);
  last_col = fil_sreadU16 (parameters->record.info + parameters->record.size-2);
  row = fil_sreadU16 (parameters->record.info);
  rkreg = parameters->record.info + 4;
  for (i = 0; i < last_col - first_col + 1; i++)
  {
    cell = xmlNewChild (parameters->this_cells, NULL, (unsigned char *)"cell",
      NULL);
    test (cell != NULL, 10);
    test_call (create_cell_coord (cell, row, i + first_col), int);
  }

  return 0;
}
