/*
   xls2xml: Converts from Microsoft Excel files to XML.
   Copyright 1999  Roberto Arturo Tena Sanchez

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published  by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 */
/*
   Roberto Arturo Tena Sanchez <arturo@directmail.org>
 */

#include <cole/cole.h>
#include <biffrec.h>
#include <gnome-xml/tree.h>
#include <p.h>
#include <param.h>


/* INTERFACEHDR - Beginning of User Interface Records */
int
pE1 (void)
{
  char number [6]; /* max number: 65535 */

  assert_return (xls2xml, parameters->record.opcode == 0xE1, 19);
  test (parameters->xml_tree_shortcuts.defaults != NULL, 19);

  parameters->xml_tree_shortcuts.ui = xmlNewChild (
	parameters->xml_tree_shortcuts.defaults, NULL, (unsigned char *)"ui", NULL);
  test (parameters->xml_tree_shortcuts.ui != NULL, 10)

  verbose ("FIXME: E1: should we save in a variable that we are in UIRecords?");

  switch (parameters->biff_version)
  {
  case BIFF_5_7:
    break;
  case BIFF_8:
    test (parameters->record.size >= 2, 15);
    parameters->code_page = fil_sreadU16 (parameters->record.info);
    sprintf (number, "%d", parameters->code_page);
    if (parameters->xml_tree_shortcuts.code_page != NULL) break;
    parameters->xml_tree_shortcuts.code_page = xmlNewChild (
	parameters->xml_tree_shortcuts.defaults, NULL, (unsigned char *)"codepage",
	(unsigned char *)number);
    test (parameters->xml_tree_shortcuts.code_page != NULL, 10);
    break;
  default:
    return 15;
  }

  return 0;
}
