/*
   xls2xml: Converts from Microsoft Excel files to XML.
   Copyright 1999  Roberto Arturo Tena Sanchez

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published  by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 */
/*
   Roberto Arturo Tena Sanchez <arturo@directmail.org>
 */

#include <cole/cole.h>
#include <biffrec.h>
#include <gnome-xml/tree.h>
#include <p.h>
#include <param.h>
#include <xmlunicode.h>


/* SST - Shared String Table */
int
pFC (void)
{
  U16 i;
  U8 * next_unicode_string;

  assert_return (xls2xml, parameters->record.opcode == 0xFC, 19);
  test (parameters->record.size >= 8, 15);
  verbose ("FIXME: pFC()");

  if (parameters->sst.strings != NULL)
  {
    verbose ("Warning: Double SST, first wins");
    return 0;
  }
  parameters->sst.count = fil_sreadU16 (parameters->record.info + 4);
  if (parameters->sst.count == 0)
  {
    /* there are no strings in SST */
    parameters->sst.strings = NULL;
    return 0;
  }
  parameters->sst.strings = malloc (parameters->sst.count * sizeof (struct str_sst_string));
  test (parameters->sst.strings != NULL, 10);

  next_unicode_string = parameters->record.info + 8;
  for (i = 0; i < parameters->sst.count; i++)
    test_call (copy_unicode_string (parameters->sst.strings+i, &next_unicode_string), int);

  return 0;
}
