/*  
   xls2xml: Converts from Microsoft Excel files to XML.
   Copyright 1999  Roberto Arturo Tena Sanchez
  
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published  by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 */
/*
   Roberto Arturo Tena Sanchez <arturo@directmail.org>
 */
  
#ifndef XMLUNICODE_H
#define XMLUNICODE_H

#ifdef __cplusplus
extern "C" {
#endif


#include <cole1compat.h>
#include <gnome-xml/tree.h>
#include <param.h>


/*
   This write the unicode string (as Excel write it) to a new xml node.
   If presult_string is not NULL, it creates child of the father and
   return the child.
   If presult_string is not NULL, it doesn't create a child, but return
   the resulting string.

   presult_child presult_string rich_string | create return return return
                                              child  child  string code
   NULL          NULL           NO            YES    NO     NO     0
   NULL          NULL           YES           YES    NO     NO     0
   NULL          NOT NULL       NO            NO     NO     YES    0
   NULL          NOT NULL       YES           NO     NO     NO     15
   NOT NULL      NULL           NO            YES    YES    NO     0
   NOT NULL      NULL           YES           YES    YES    NO     0
   NOT NULL      NOT NULL       NO            YES    YES    YES    0
   NOT NULL      NOT NULL       YES           YES    YES    NO     15
 */
int write_unicode_xml_child (xmlNodePtr father, xmlNodePtr * presult_child,
			     char * children_name, U8 * unicodestring,
			     U16 len_unicodestring,
			     unsigned char ** presult_string);

/* create a new copy of the string pointed by *punicode_string and write its size and the string itself in pdest, and when it finish makes *punicode_string point to the end of the original unicode string */
int copy_unicode_string (struct str_sst_string * pdest, U8 ** punicode_string);

#ifdef __cplusplus
}
#endif

#endif /* XMLUNICODE_H */
